<?php
function mtheme_insta_widget() {
	register_widget( 'mtheme_instagram_widget' );
}
add_action( 'widgets_init', 'mtheme_insta_widget' );

class mtheme_instagram_widget extends WP_Widget {

	function __construct() {
		$widget_ops = array( 'classname' => 'mtheme-instagram-feed', 'description' => __( 'Displays your latest Instagram photos', 'mtheme' ) );
		parent::__construct( 'mtheme-instagram-feed', __( 'THEME - Instagram', 'mtheme' ), $widget_ops );
	}

	function widget( $args, $instance ) {

		extract( $args, EXTR_SKIP );

		$title = empty( $instance['title'] ) ? '' : apply_filters( 'widget_title', $instance['title'] );
		$limit = empty( $instance['number'] ) ? 7 : $instance['number'];
		$target = empty( $instance['target'] ) ? '_self' : $instance['target'];
		$link = empty( $instance['link'] ) ? '' : $instance['link'];

		echo $before_widget;
		if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };

		do_action( 'mtheme_before_widget', $instance );

		$count=0;
		$cache_renew = 0;
		
		$columns = 1;
		$insta_data = do_shortcode('[instagram-feed showfollow="false" showbutton="false" showbio="true" showheader="false" cols="4" num="12" imageres="medium" class="theme-footer-instagram"]');
		echo '<div id="instagram-grid-gen">'.$insta_data.'</div>';

		do_action( 'mtheme_after_widget', $instance );

		echo $after_widget;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => __( 'Instagram', 'mtheme' ), 'username' => '', 'link' => __( 'Follow Us', 'mtheme' ), 'number' => 7, 'target' => '_self' ) );
		$title = esc_attr( $instance['title'] );
		$number = absint( $instance['number'] );
		$target = esc_attr( $instance['target'] );
		$link = esc_attr( $instance['link'] );
		?>
		<p><label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title', 'mtheme' ); ?>: <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
		<?php
		if ( function_exists('of_get_option' ) )  {
			$token = of_get_option( 'insta_token' );
			if ( '' === $token ) {
				echo '<p style="color:#ff0000;">Instagram token not found.<br/>Please enter Instagram token to theme options in general tab.</p>';
			}
		}
		?>
		<p><label for="<?php echo $this->get_field_id( 'number' ); ?>"><?php _e( 'Number of photos', 'mtheme' ); ?>: <input class="widefat" id="<?php echo $this->get_field_id( 'number' ); ?>" name="<?php echo $this->get_field_name( 'number' ); ?>" type="text" value="<?php echo $number; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id( 'target' ); ?>"><?php _e( 'Open links in', 'mtheme' ); ?>:</label>
			<select id="<?php echo $this->get_field_id( 'target' ); ?>" name="<?php echo $this->get_field_name( 'target' ); ?>" class="widefat">
				<option value="_self" <?php selected( '_self', $target ) ?>><?php _e( 'Current window (_self)', 'mtheme' ); ?></option>
				<option value="_blank" <?php selected( '_blank', $target ) ?>><?php _e( 'New window (_blank)', 'mtheme' ); ?></option>
			</select>
		</p>
		<?php

	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['number'] = !absint( $new_instance['number'] ) ? 7 : $new_instance['number'];
		$instance['target'] = ( ( $new_instance['target'] == '_self' || $new_instance['target'] == '_blank' ) ? $new_instance['target'] : '_self' );
		$instance['link'] = strip_tags( $new_instance['link'] );
		return $instance;
	}

}
